package xic.ast;

import xic.visitors.NodeVisitor;
import edu.cornell.cs.cs4120.xi.Position;

public class BoolLiteral extends Literal {
	private boolean value;

	public BoolLiteral(Position pos, boolean value) {
		super(pos);
		this.value = value;
	}

	public boolean value() {
		return value;
	}

    public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}
    
    public Copyable copy() {
    	Expr expr = new BoolLiteral(position, value);
    	expr.type = type;
    	return expr;
    }

	public String label() {
		return "boolLiteral " + value;
	}
}