package xic.ast;

import xic.visitors.NodeVisitor;
import edu.cornell.cs.cs4120.xi.Position;

/**
 * Describes a local/global variable reference or
 * a global function reference. Additional semantic
 * information is required to distinguish between them.
 */
public class Identifier extends Expr {
	private String name;

	public Identifier(Position pos, String name) {
		super(pos);
		this.name = name;
	}

	public String name() {
		return name;
	}
	
	public String label() {
		return "id " + name;
	}
	
	public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}

	public Copyable copy() {
		Expr expr = new Identifier(position, name);
    	expr.type = type;
    	expr.dataSource = dataSource;
    	return expr;
	}
}
