package xic.ast;

import java.util.Arrays;

import xic.visitors.NodeVisitor;

import edu.cornell.cs.cs4120.xi.Position;
import edu.cornell.cs.cs4120.util.VisualizableTreeNode;

/**
 * Expression used to represent the length keyword
 */
public class Length extends Expr {
	private Expr expr;

	public Length(Position pos, Expr expr) {
		super(pos);
		this.expr = expr;
	}

	public Expr expr() {
		return expr;
	}

	public Iterable<VisualizableTreeNode> children() {
		return Arrays.asList(new VisualizableTreeNode[] {
				expr
		});
	}

    public ASTNode visitChildren(NodeVisitor v) {
    	Expr expr = (Expr) v.visit(this, this.expr);

		if (expr != this.expr)
			return new Length(position, expr);

		return this;
	}
    
    public Copyable copy() {
		Expr expr = new Length(position, this.expr);
    	expr.type = type;
    	expr.dataSource = dataSource;
    	return expr;
    }

	public String label() {
		return "length";
	}
}
