package xic.ast;

import xic.ErrorSink;
import edu.cornell.cs.cs4120.xi.Position;

/**
 * Base class of all type nodes
 */
public abstract class TypeNode extends ASTNode {
	public TypeNode(Position pos) {
		super(pos);
	}

	/// Create a type node without position information
	public TypeNode() {
		super(null);
	}
	
	// for type checking, return true if the type layout are equal
	abstract public void match (TypeNode node, ErrorSink sink);
	abstract public int size();
	abstract public boolean isSubtypeOf(TypeNode node);
	abstract public boolean isIdenticalType(TypeNode node);
}
