package xic.ast;

/**
 * Represents an AST node with a certain associated type.
 * Implemented by <code>Expr</code> and <code>*Decl</code>.
 */
public interface Typed {
	/**
	 * Return the type associated with the node
	 */
	TypeNode getType();
	
	/**
	 * "Set" the type of a typed node -- if this actually
	 * produces a change, instead return an update copy of
	 * the node. Otherwise, <tt>this</tt> is returned. 
	 */
	Typed setType(TypeNode type);
}
