package xic.ast;

import xic.visitors.NodeVisitor;
import edu.cornell.cs.cs4120.xi.Position;

/**
 * Describes a single use statement in the
 * source code. The name parameter is limited
 * the set of strings representable by an identifier.
 */
public class UseStmt extends ASTNode {
	private String name;

	public UseStmt(Position pos, String name) {
		super(pos);
		this.name = name;
	}

	public String name() {
		return name;
	}

	public String label() {
		return "use " + name;
	}

    public Copyable copy() {
		return new UseStmt(position, name); 
    }

	public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}
}
