package xic.codegen.matchers;

import xic.codegen.Instr;
import xic.codegen.InstrList;
import xic.codegen.Matcher;
import xic.codegen.Tile;
import xic.codegen.Tiler;
import xic.ir.IRExpr;
import xic.ir.IRJump;
import xic.ir.IRName;
import xic.ir.IRNode;
import xic.ir.NameGenerator;

public class JumpMatcher implements Matcher {
	public Tile match(IRNode node, Tiler tiler) {
		if (!(node instanceof IRJump))
			return null;
		
		IRExpr target = ((IRJump) node).target();
		if (!(target instanceof IRName))
			return null;

		final String jumpTarget = ((IRName) target).name();
		return new Tile() {
			public int estimateCost() {
				return 1;
			}

			public String translate(InstrList il, NameGenerator ng) {
				Instr.Op op = new Instr.Op(Instr.Op.Type.IMMEDIATE);
				op.setImmediateName(jumpTarget);
				il.add(new Instr("jmp", op));
				return null;
			}
		};
	}
}
